'--------------------------------------------------------------
'                 (c) 2006 - j.p.
'--------------------------------------------------------------
' file: RegulacjaPWM / Listing3.BAS ver. 1.0 15-05-2006
'--------------------------------------------------------------
' Regulacja obrotw PWM

$crystal = 16000000
$regfile = "89c2051.DAT"

Dim Motor_on As Bit                                           ' =1 gdy silnik pracuje
Dim Keylock As Bit                                            ' blokada klawiatury
Dim Markloop As Bit                                           ' znacznik wykonania petli glow.
Dim Keyb As Byte                                              ' biezacy stan klawiatury
Dim Keyp As Byte                                              ' poprzedni stan klawiatury
Dim Krokww As Byte                                            ' numer kroku wsp. wypelnienia
Dim Ww As Byte                                                ' wartosc wsp. wypelnienia
Dim Mod10 As Byte                                             ' licznik modulo 10
Declare Sub Przelicz_ww()

Config Timer0 = Timer , Gate = Internal , Mode = 0
      ' Mode = 0 : 13-bit timer
      ' Dla 16 MHz jest INT co 6.144 ms tj. ok.162 razy na sekunde
On Timer0 Timer_0_int Nosave                                  ' Nie ma auto-push rejestrow przy przerwaniu
      'Inicjowanie zmiennych:
Keyb = 255
Keyp = 255
Krokww = 0
Ww = 0
Reset Keylock
Reset Motor_on
Reset Markloop
Priority Set Timer0
Enable Timer0
Enable Interrupts
Start Timer0

      ' Ptla glwna programu
Mainloop:
If Markloop = 0 Then Goto Endloop                             ' Petla glowna 16 razy / sek.
      ' Obsluga klawiatury:
P1 = P1 Or &B11110000
Keyb = P1 Or &B00001111                                       ' Odczyt stanu klawiatury
If Keyb <> Keyp Then
   Keyp = Keyb
Else                                                          ' Keyb=Keyp tj.potwierdzony klawisz
   If Keylock = 1 And Keyb <> 255 Then Goto Endloop
   Select Case Keyb
     Case &B11111111:                                         ' Nie wcisniety zaden klawisz
       Reset Keylock
     Case &B11101111:                                         ' Klawisz K1 (Wl/Wyl)
      If Motor_on = 0 Then
         Set Motor_on
         Krokww = 4                                           ' Predkosc poczatkowa
         Call Przelicz_ww()                                   ' Przeliczenie wsp.wypelnienia
      Else
         Reset Motor_on                                       ' Wylaczenie silnika
         Ww = 0
         P1.2 = 0
      End If
      Set Keylock
     Case &B11011111:                                         ' Klawisz K2 (+)
      If Motor_on = 1 And Krokww < 7 Then
         Incr Krokww
         Call Przelicz_ww()
      End If
      Set Keylock
     Case &B10111111:                                         ' Klawisz K3 (-)
      If Motor_on = 1 And Krokww > 0 Then
         Decr Krokww
         Call Przelicz_ww()
      End If
      Set Keylock
   End Select
End If

Endloop:
Idle                                                          ' stan uspienia
Goto Mainloop

End


Sub Przelicz_ww()                                             ' Przeliczenie kroku na wsp.wypelnienia
Ww = Lookup(krokww , Wart_ww)                                 ' a potem na wartosc dla TH0
If Ww = 32 Then
   Ww = 255
Else
   Ww = Ww * 8                                                ' Przesun. o 3 bity w lewo
End If

End Sub
Wart_ww:
Data 6 , 9 , 12 , 16 , 20 , 24 , 28 , 32                      ' Wspol.wypeln. = Ww /32

Timer_0_int:
$asm
      PUSH Acc
      PUSH PSW
      CLR TCON.4
      MOV A, {Ww}
      JNZ NieZero
      SETB P1.2               ' gdy Ww=0 -> TH0=128, silnik wyl.
      MOV A, #128
      SJMP ZapisWw
Niezero:
      CJNE A, #255, Nie255
      CLR P1.2                ' gdy Ww=31 -> TH0=128, silnik max
      MOV A, #128
      SJMP ZapisWw
Nie255:
      JNB P1.2, Sil_ON
      CLR P1.2
      MOV A, {Ww}             ' PWM = ON, TH0=256-Ww (tj Ww=32-Ww)
      CPL A
      INC A
      ANL A, #&B11111000
      SJMP ZapisWw
Sil_on:
      SETB P1.2               ' PWM=OFF, TH0=Ww
      MOV A, {Ww}
Zapisww:
      MOV TH0, A              ' zapis  -> TH0
      SETB TCON.4
      MOV A, {Mod10}          ' licznik modulo 10
      INC A
      CJNE A, #10, NIE10
      CLR A
      SETB {Markloop}
Nie10:
      MOV {Mod10}, A
      POP PSW
      POP Acc
$end Asm

Return