'--------------------------------------------------------------
'                 (c) 2006 - j.p.
'--------------------------------------------------------------
' file: SilnikKrok / Listing5.BAS ver. 1.0 15-08-2006
'--------------------------------------------------------------
' ** Sterowanie silnikiem krokowym **

$crystal = 16000000
$regfile = "89c2051.DAT"
' Zmienne :
Dim Flagi As Byte                                             ' Bajt zmiennych bitowych
Dim Numb As Byte                                              ' Ilo bajtow odebranych / nadanych
Dim Inb As Byte                                               ' Bajt odebrany (wyslany) z RS232
Dim Param As Byte                                             ' Parametr rozkazu z RS232
Dim Rozk As Byte                                              ' Kod rozkazu z RS232
Dim Czaskroku As Byte                                         ' Zadany czas miedzy krokami n x 5ms
Dim Poz_akt As Word                                           ' Pozycja aktualna napedu
Dim Poz_docel As Word                                         ' Pozycja docelowa napedu
Dim Timer_krok As Byte                                        ' Odliczanie interwalow n x 5 ms
Dim Mod4 As Byte                                              ' Licznik modulo 4
Dim Wyjscie As Byte                                           ' Stan wyjsc sterujacych
' Zmienne bitowe:
Motor_on Alias Flagi.0                                        ' =1 gdy silnik aktywny
Rozkrdy Alias Flagi.1                                         ' =1 gdy jest rozkaz z RS232
Lkrok Alias Flagi.2                                           ' Znacznik kroku w lewo
Bld Alias Flagi.3                                             ' Znacznik bledu
Zero_on Alias Flagi.4                                         ' Znacznik wykonywania funkcji zerowania pozycji
Poz_ok Alias Flagi.5                                          ' Znacznik osiagniecia pozycji docelowej
Test_poz Alias Flagi.6                                        ' = 1 gdy wykonano test poprawnosci pozycji
Bkr Alias Flagi.7                                             ' Znacznik bledu krokow
Dim Goloop As Bit                                             ' Znacznik wykonania petli glownej

Ren Alias Scon.4                                              ' Flagi portu szeregowego
Ri Alias Scon.0
Ti Alias Scon.1

' Port szereg. MODE 1 :
Scon = &B01010000
Config Timer0 = Timer , Gate = Internal , Mode = 0
Counter0 = 1526
' Mode = 0 : 13-bit timer
' Rejestr TH0 jest ladowany tak,
' aby dla 16 MHz bylo INT-T0 co 5 ms tj.200 razy na sekunde
On Timer0 Timer_0_int
On Serial Rs_com_int
Config Timer1 = Timer , Gate = Internal , Mode = 2
' Timer1 obsluguje transmisje szeregow
Th1 = 239                                                     ' Transmisja 2400 bps
 ' Dla 4800 bps:  TH1= 247
 ' Inicjowanie zmiennych:
Numb = 0
Flagi = 0
Wyjscie = 255
Set Test_poz
Timer_krok = 0
Czaskroku = 10
Enable Serial
Enable Timer1
Start Timer1
Enable Timer0
Start Timer0
Enable Interrupts

Mainloop:                                                     ' Poczatek petli glownej

If Goloop = 0 Then Goto Loopend
Reset Goloop
If Rozkrdy = 1 Then                                           ' Dekodowanie rozkazu
   Reset Ren
   Reset Rozkrdy
   Select Case Rozk
      Case "S":                                               ' Rozk. Stop
         Wyjscie = 255
         P1 = Wyjscie
         Flagi = 0
         Set Test_poz
         Call Start_transm
      Case "H":                                               ' Poz.docel. H
         If Motor_on = 0 Then
            Bld = 1
         Else
            mov {Poz_docel + 1}, {Param}                      ' Starszy bajt zmiennej
         End If
         Call Start_transm
      Case "L":                                               ' Poz.docel. L
         If Motor_on = 0 Then
            Bld = 1
         Else
            mov {Poz_docel + 0}, {Param}                      ' Mlodszy bajt zmiennej
            Lkrok = 0
            If Poz_docel < Poz_akt Then Lkrok = 1
            Timer_krok = Czaskroku                            ' Start silnika
         End If
      Case "T":                                               ' Czas kroku
         Czaskroku = Param
         If Czaskroku = 0 Then
            Czaskroku = 10
            Set Bld
         End If
         Call Start_transm
      Case "Z":                                               ' Zerowanie pozycji
         Poz_akt = 512
         Poz_docel = 0
         Set Zero_on
         Set Lkrok
         If Czaskroku = 0 Then Czaskroku = 10
         Reset Test_poz
         If Mod4 > 3 Then Mod4 = 0
         Timer_krok = Czaskroku
      Case Else:
         Bld = 1
   End Select
End If
If Bld = 1 Then
   Call Start_transm
Else
   If Poz_ok = 1 And Test_poz = 1 Then
      Reset Poz_ok
      Call Start_transm
   End If
End If
Loopend:
Idle                                                          ' stan uspienia
Goto Mainloop

End

 '** Obsluga przerwania portu szeregowego **
Rs_com_int:                                                   ' Obsluga transmisji RS232
If Ti = 1 Then Goto Transmisja
Reset Ri                                                      ' Odbior danych
Inb = Sbuf
Select Case Numb
   Case 0:                                                    ' Bajt naglowka
     If Inb = "$" Then Numb = 1
   Case 1:                                                    'Bajt rozkazu
     Rozk = Inb
     Incr Numb
   Case 2:
     Inb = Inb And &B00001111                                 ' Konwersja 3 cyfr ASCII
     Param = Inb * 100                                        ' na wartosc binarna bajtu
     Incr Numb
   Case 3:
     Inb = Inb And &B00001111
     Inb = Inb * 10
     Param = Param + Inb
     Incr Numb
   Case 4:
     Inb = Inb And &B00001111
     Param = Param + Inb
     Numb = 0
     Set Rozkrdy
   End Select
Goto Koniecrs

Transmisja:
Reset Ti                                                      ' Nadawanie
Incr Numb
Select Case Numb
   Case 1:
      If Inb = "O" Then
         Inb = "K"                                            ' 2-gi znak komunikatu
      Else
         Inb = "1"
         If Bkr = 1 Then
            Inb = "2"
            Reset Bkr
         End If
      End If
      Sbuf = Inb
   Case 2 :
      Sbuf = &H0D                                             ' wysyla <CR>
   Case 3:
      Sbuf = &H0A                                             ' wysyla <LF>
   Case 4:
      Numb = 0
      Set Ren
End Select

Koniecrs:
Return

 '** Obsluga przerwania Timer0 **
Timer_0_int:
Stop Timer0
Counter0 = 1526
Start Timer0
If Motor_on = 0 And Zero_on = 0 Then Goto Koniectim0          ' Silnik wylaczony
' Kontrola pozycji z poprzedniego kroku:
If Test_poz = 0 Then
   P3.2 = 1
   ' Wej. P3.2 : czujnik pozycji zerowej - mechaniczny, styk NC
   Reset Bld
   If Zero_on = 1 And P3.2 = 1 Then                           ' P3.2 - czujnik pozycji zerowej
      Poz_akt = 1                                             ' funkcja zerowania pozycji
      Set Poz_ok
      Timer_krok = 0
      Reset Zero_on
      Motor_on = 1
   End If
   If Zero_on = 0 Then                                        ' kontrola poprawnosci kroku
      If Poz_akt < 2 And P3.2 = 0 Then Set Bld                ' tolerancja bledu +- 1 kroku
      If Poz_akt > 2 And P3.2 = 1 Then
         If Lkrok = 1 Then Set Bld
      End If
      If Bld = 1 Then
         Wyjscie = 255                                        ' Wylaczenie silnika
         P1 = Wyjscie
         Flagi = 0
         Timer_krok = 0
         Set Bkr
         Set Bld
      End If
   End If
   Set Test_poz                                               ' Znacznik wykonania testu
End If
If Timer_krok = 0 Then Goto Koniectim0                        ' silnik nie obraca sie

' Wykonanie sekwencji kroku:
Decr Timer_krok                                               ' odlicza czas kroku
If Timer_krok <> 0 Then Goto Koniectim0
Timer_krok = Czaskroku
If Lkrok = 0 Then                                             ' krok w prawo
   Incr Mod4
   If Mod4 = 4 Then Mod4 = 0
   Wyjscie = Lookup(mod4 , Sekwencja)
   Incr Poz_akt
Else                                                          ' krok w lewo
   Decr Mod4
   If Mod4 = 255 Then Mod4 = 3
   Wyjscie = Lookup(mod4 , Sekwencja)
   Decr Poz_akt
End If
P1 = Wyjscie
' Kontrola osiagniecia pozycji docelowej po kroku:
Test_poz = 0
If Poz_akt = Poz_docel And Zero_on = 0 Then
   Set Poz_ok
   Timer_krok = 0
Else
   If Poz_akt >= 512 Then                                     ' Przekroczenie liczby krokow
      Wyjscie = 255
      P1 = Wyjscie
      Flagi = 0
      Set Test_poz
      Timer_krok = 0
      Bld = 1
      Bkr = 1
   End If
End If
Koniectim0:
Set Goloop
Return

 '** Podprogram rozpoczecia transmisji **
Sub Start_transm()
Numb = 0
Inb = "O"
If Bld = 1 Then Inb = "E"
Reset Bld
Sbuf = Inb
End Sub

Sekwencja:                                                    ' sekwencje bitowe wyj (P1.0...P1.3)
' Sterowanie falowe :
Data &B11110111 , &B11111011 , &B11111101 , &B11111110

' Dla sterowania pelnokrokowego:
'Data &B11110011 , &B11111001 , &B11111100 , &B11110110